Subject: Re: bug#16906: 24.3.50; Gnus hangs on g command (gnus-group-get-news) after changing wireless access point

From: [email-masked] (N. Jackson)
Date: Mon, 08 Feb 2016 15:03:20 -0400

Hi Lars,

At 17:48 +1100 on Sunday 2016-02-07, Lars Ingebrigtsen wrote:

> [email-masked] (N. Jackson) writes:
>
>> For some time Gnus has been hanging when checking for new articles with
>> the g command (gnus-group-get-gnus) after changing wireless access
>> points.
>
> Is this with IMAP or NNTP connections?

That's a good question.

Sorry for the delayed response. Testing is a bit slow as I have to
walk across town (or at least across campus) to get a new access
point after making changes.

It _seems_ that [and I stress _seems_ because I'm still somewhat
mystified by what's going on] it is with NNTP connections.

I have set gnus-verbose and gnus-verbose-backends both to 10 to help
see what is going on. Unfortunately that doesn't seem to give much
detail.

[BTW: Section 9.20 Various Various in the manual states that the
default value for gnus-verbose is seven, but in fact, in current
Emacs the default is six.]

I have Gnus configured so that I have the following servers:

     {nnfolder:archive} (opened)
     {nnfolder:} (opened)
     {nnimap:Local Dovecot Mailstore} (opened)
     {nntp:news.gmane.org} (opened)
     {nntp:dusty} (opened)
     {nntp:nntp.aioe.org} (opened)

"Local Dovecot Mailstore" is my personal IMAP server on localhost.
It shouldn't be affected by Internet connectivity unless I have it
set up wrong. It is my only mail source in Gnus. The server called
"dusty" is a second instance of Gmane. My primary select method is
nnnil. The local IMAP server and the three NNTP servers are my
secondary select methods.

When I hit `g' to fetch messages, when Gnus doesn't hang, I see the
following in the Messages buffer:

    Checking new news...
    Reading active file via nnnil...done
    Reading active file from archive via nnfolder...
    Opening nnfolder server on archive...done
    Reading active file from archive via nnfolder...done
    Reading active file via nnfolder...
    Opening nnfolder server...done
    Reading incoming mail from file...
    nnfolder: Reading incoming mail (no new mail)...done
    Reading active file via nnfolder...done
    Checking new news...done

When I shift my location to another access point, the first time I
hit `g' in Gnus, Gnus hangs and I have to cancel with `C-g' three
times. Only on the fourth `g' does Gnus complete retrieving
messages. (That is, my key strokes are `g' `C-g' `g' `C-g' `g' `C-g'
`g'.) The record in the Messages buffer is:

    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Reading active file from archive via nnfolder...
    Opening nnfolder server on archive...done
    Reading active file from archive via nnfolder...done
    Reading active file via nnfolder...
    Opening nnfolder server...done
    Reading incoming mail from file...
    nnfolder: Reading incoming mail (no new mail)...done
    Reading active file via nnfolder...done
    Checking new news...done

Unfortunately, even though I see the "Quit" messages where I hit
`C-g', I don't understand from these messages whether the hang is
while checking the local IMAP server of if it is while checking one
of the NNTP servers.

Next I tried to check only the IMAP server and not the news servers.
In my settings file I commented out all the forms where I add the
news servers to gnus-secondary-select-methods. This was only
partially successful though, because after restarting Emacs and
Gnus, I had the following servers:

     {nnfolder:archive} (opened)
     {nnfolder:} (opened)
     {nntp:news.gmane.org} (opened)
     {nnimap:Local Dovecot Mailstore} (opened)

I don't understand where Gmane is coming from here. I don't think it
is from any of my settings files, it is commented out there. In any
case, I pushed on with my test to see what would happen.

After moving to a new location, checking messages with `g' resulted
in only one hang, with the following in Messages:

    Checking new news...
    Opening connection to localhost via tls...
    Opening connection to localhost...done
    Reading active file via nnnil...done
    nnimap read 0k from localhost (initial sync of 1 group; please wait)
    Reading active file from archive via nnfolder...
    Opening nnfolder server on archive...done
    Reading active file from archive via nnfolder...done
    Reading active file via nnfolder...
    Opening nnfolder server...done
    Reading incoming mail from file...
    nnfolder: Reading incoming mail (no new mail)...done
    Reading active file via nnfolder...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Reading active file from archive via nnfolder...
    Opening nnfolder server on archive...done
    Reading active file from archive via nnfolder...done
    Reading active file via nnfolder...
    Opening nnfolder server...done
    Reading incoming mail from file...
    nnfolder: Reading incoming mail (no new mail)...done
    Reading active file via nnfolder...done
    Checking new news...done

It looks to me that Gnus successfully checked the IMAP server on
localhost _before_ the hang, suggesting that the hang was connecting
to Gmane. Maybe?

On the other hand, after I re-instated the three entries for the
news servers in my settings, and commented out the entry for my
local IMAP server, and rested Emacs and Gnus, the servers were:

     {nnfolder:archive} (opened)
     {nnfolder:} (opened)
     {nntp:news.gmane.org} (opened)
     {nntp:dusty} (opened)
     {nntp:nntp.aioe.org} (opened)

After shifting locations and hitting `g', Gnus hung three times
again:

    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Quit
    Checking new news...
    Reading active file via nnnil...done
    Reading active file from archive via nnfolder...
    Opening nnfolder server on archive...done
    Reading active file from archive via nnfolder...done
    Reading active file via nnfolder...
    Opening nnfolder server...done
    Reading incoming mail from file...
    nnfolder: Reading incoming mail (no new mail)...done
    Reading active file via nnfolder...done
    Checking new news...done

So it looks as if it is the NNTP servers that Gnus is hanging after
changing wireless access points. [Or after waking my system from
sleep, I suppose.]

Please let me know what further information I can provide. Thank
you.

Regards,
N.